Index: include/class.history.php
===================================================================
--- include/class.history.php	(revision 3321)
+++ include/class.history.php	(working copy)
@@ -266,14 +266,14 @@
                 "other"     =>  array()
             );
             if (count($res) > 0) {
+                if ($_POST['show_per_issue']) {
+                    Time_Tracking::fillTimeSpentByIssueAndTime($res, $usr_id, $start, $end);
+                }
                 foreach ($res as $index => $row) {
                     if ((!empty($row["iss_customer_id"])) && (Customer::hasCustomerIntegration($row['iss_prj_id']))) {
                         $details = Customer::getDetails($row["iss_prj_id"], $row["iss_customer_id"]);
                         $row["customer_name"] = $details["customer_name"];
                     }
-                    $timeForIssue = Time_Tracking::getTimeSpentByIssueAndTime($row['iss_id'], $usr_id, $start, $end);
-                    $row['time_spent'] = Misc::getFormattedTime($timeForIssue, false);
-
                     if (($separate_closed) && ($row['sta_is_closed'] == 1)) {
                         $data['closed'][] = $row;
                     } else {
Index: include/class.time_tracking.php
===================================================================
--- include/class.time_tracking.php	(revision 3321)
+++ include/class.time_tracking.php	(working copy)
@@ -571,6 +571,46 @@
             return $res;
         }
     }
+    /**
+     * Method used to add time spent on issue to a list of user issues.
+     *
+     * @access  private
+     * @param   array $res User issues
+     * @param   string $usr_id The ID of the user this report is for.
+     * @param   integer $start The timestamp of the beginning of the report.
+     * @param   integer $end The timestamp of the end of this report.
+     * @return  void
+     */
+    function fillTimeSpentByIssueAndTime(&$res, $usr_id, $start, $end)
+    {
+
+        $issue_ids = array();
+        for ($i = 0; $i < count($res); $i++) {
+            $issue_ids[] = Misc::escapeInteger($res[$i]["iss_id"]);
+        }
+        $ids = implode(", ", $issue_ids);
+
+        $stmt = "SELECT
+                    ttr_iss_id, sum(ttr_time_spent)
+                 FROM
+                    " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "time_tracking
+                 WHERE
+                    ttr_usr_id = " . Misc::escapeInteger($usr_id) . " AND
+                    ttr_created_date BETWEEN '" . Misc::escapeString($start) . "' AND '" . Misc::escapeString($end) . "' AND
+                    ttr_iss_id in ($ids)
+                 GROUP BY ttr_iss_id";
+        $result = $GLOBALS["db_api"]->dbh->getAssoc($stmt);
+
+        if (PEAR::isError($result)) {
+            Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
+            return 0;
+        } else {
+            foreach($res as $key => $item) {
+                @$res[$key]['it_spent'] = $result[$item['iss_id']];
+                @$res[$key]['time_spent'] = Misc::getFormattedTime($result[$item['iss_id']], false);
+            }
+        }
+    }
 }
 
 // benchmarking the included file (aka setup time)
Index: reports/weekly.php
===================================================================
--- reports/weekly.php	(revision 3321)
+++ reports/weekly.php	(working copy)
@@ -76,6 +76,12 @@
 
     // print out emails
     $data = Report::getWeeklyReport($_POST["developer"], $dates[0], $dates[1], @$_REQUEST['separate_closed'], @$_REQUEST['ignore_statuses']);
+    // order issues by time spent on them
+    if (isset($_POST['show_per_issue'])) {
+        $sort_function = create_function('$a,$b', 'if ($a["it_spent"] == $b["it_spent"]) {return 0;} return ($a["it_spent"] < $b["it_spent"]) ? 1 : -1;');
+        @usort($data['issues']['closed'], $sort_function);
+        @usort($data['issues']['other'], $sort_function);
+    }
     $tpl->assign("data", $data);
 }
 
